import { AbstractCommand } from '../Command/AbstractCommand';
export declare type CliCommandType = Partial<{
    token: string;
    commandLine: string;
    Command: typeof AbstractCommand;
    action: string;
    args: {
        name: string;
        required: boolean;
    }[];
    config: CliCommandConfigType;
}>;
export declare type CliCommandConfigType = Partial<{
    description: string;
    options: CliCommandOptionsType;
}>;
export declare type CliCommandOptionsType = Partial<{
    [option: string]: CliCommandOptionType;
}>;
export declare type CliCommandOptionType = Partial<{
    alias: string;
    description: string;
    defaultTo: any;
    required: boolean;
}>;
export declare type CliProgramType = Partial<{
    program: string;
    config: CliProgramConfigType;
}>;
export declare type CliProgramConfigType = Partial<{
    commands: CliCommandType[];
}>;
