/// <reference types="koa-bodyparser" />
import Koa, { Middleware } from 'koa';
import { ApplicationModes } from '../Application';
import { AbstractMiddleware } from '../Middleware';
export declare class ServerService {
    private readonly server;
    private readonly port;
    private middleware;
    constructor(mode: ApplicationModes, port: number, middleware: Array<Middleware | AbstractMiddleware>);
    use(...middlewares: Array<Middleware | AbstractMiddleware>): this;
    useBefore(middleware: string | Middleware, ...middlewares: Array<Middleware>): this;
    useAfter(middleware: string | Middleware, ...middlewares: Array<Middleware>): this;
    replace(middleware: string | Middleware, ...middlewares: Array<Middleware>): this;
    updateMiddleware(at: number, remove: number, ...middlewares: Array<Middleware>): this;
    indexOfMiddleware(middleware: string | typeof AbstractMiddleware | Function): number;
    getServer(): Koa;
    start(): this;
}
